#ifndef _3D_UTILS_H
#define _3D_UTILS_H

// This code was taken from Professor Michael Gleicher's sample project
// I have add some functions to the end of this though.

// some useful routines for writing 3D interactive programs
// written for CS638 - Michael Gleicher, November 1999

// draw a cube
// centered at x,y,z
// sides of length l
void drawCube(double x, double y, double z, double l);

// draw a box
// centered at x,y,z
// width and height = l
// (saves some cycles for 2d) ;
void drawBox(double x, double y, double z, double w, double h);

// This function will draw a line between the point1 and point2 specified
void drawLine(double x1, double y1, double z1, double x2, double y2, double z2);

// multiply a "shadow matrix" onto the stack to smash the objects onto
// the floor
void dropShadowMatrix(float floorHeight=0);

// This function draws a GLQuadric ellipse between two points located anywhere in
// space.
void  ellipsify(float x1, float y1, float z1, float x2, float y2, float z2) ;

// A simple dot product of two 3-vec's.  The return value is the singular result of
// the operation.
float dotProduct(float x1, float y1, float z1, float x2, float y2, float z2) ;

// A simple cross product of two 3-vec's.  The resulting 3-vec is returned by reference
// as the last three floating point values passed-in.
void crossProduct(float ax, float ay, float az, float bx, float by, float bz, float &cx, float &cy, float &cz);

// This function computes the cardinal spline curves between a series of four ponits.
double cardinal( double u, double p0, double p1, double p2, double p3, double tension );

#endif
