#ifndef RUNBUTTON_H
#define RUNBUTTON_H

#pragma warning(disable: 4786)
#pragma warning(disable: 4788)

#include "fltkIncludes.h"

// This codes was borrow from Professor Michael Gleicher
// I did make a couple changes though.  I added a velocity slider class at the end
// This class is then able to set the RunSlider's step value in order to control the velocity

// $Header: /home2/cvsroot/proj2/RunButton.h,v 1.7 2000/04/19 01:09:14 cvs Exp $
// written October, 1999 by Michael L. Gleicher
//
// CS638 Example code - this provides a utility routine to help with animation
//
// This file implements a "play" button. The idea is that you creat a window that
// does your drawing. When redrawing, this window looks at a slider to see what
// time it is, so it knows what part of the animation to draw.
//
// The slider must call the window's redraw function whenever the time changes.
//
// The play button, when pressed, advances the slider forward a timestep continually.
// In order to do this, it installs itself in the FlTk "Idle" loop so it gets called
// periodically.
//
// See the Simple4.cpp program for an example of how to use this


// the time slider
// the only thing it does is create itself. all of its work happens
// in a callback it installs

#include <vector>

typedef std::vector<Fl_Widget*> widgetsToUpdateVector;
static widgetsToUpdateVector wtuV;

class RunSlider  : public Fl_Value_Slider {
public:
	RunSlider(Fl_Widget* draw,		// what needs to be told to redraw
				  int length,			// how many frames is the animation
				  int x, int y, int w,int h);			// standard slider parameters

	void RunLength(int) ;
	
	// Adds any widget to the damage list of this slider so that it will get updated
	// as the slider changes
	void addWidgetToDamageList( Fl_Widget* w );

	// Remove any widget from the damage list of the slider
	void removeWidgetFromDamageList( Fl_Widget* w );

  };


// the run button - advances the slider periodically
// note: this is hard coded to 30 frames per second
class RunButton : public Fl_Light_Button {
public:
	RunButton(Fl_Slider* time,		// what to advance
			  int x, int y, int w, int h);
	~RunButton();					// remove the idle function

	Fl_Slider* slider;				// need to remember this
	long lastRedraw;				// time of last redraw
	float frameTime;				// time each individual frame takes

	// Call this function to set the time for each individual frame
	void setFrameTime(float);
};

#endif
